module StrongComp where
open import Utils
open import Syntax
open import SyntacticLemmas
open import Value
open import BigStep

mutual
  data SC : forall {Γ} -> VTy Γ -> Set where
    sU : forall {Γ} -> SC {Γ} VU
    sEl : forall {Γ} -> (σ : Val Γ U) -> SCV sU refl⁺ σ -> SC (VEl σ)
    sΠ : forall {Γ Δ}(σ : Ty Δ)(τ : Ty (Δ , σ))(vs : Env Γ Δ) -> SCE vs -> 
         (σ' : VTy Γ)(p : σ [ embˢ vs ]⁺ ≡⁺ emb⁺ σ')
         (sσ' : SC σ') ->
         ((v : Val Γ (σ [ embˢ vs ]⁺)) -> SCV sσ' p v -> 
          Σ (VTy Γ) \τ' -> ev⁺ τ & vs << v ⇓ τ' × SC τ') ->
         SC (VΠ σ τ vs)

  SCV : forall {Γ Γ'}{σ : VTy Γ}{ρ} -> SC σ -> ρ ≡⁺ emb⁺ σ -> Val Γ' ρ -> Set
  SCV sU                                 p v = One 
  SCV (sEl σ sσ)                         p v = One
  SCV {Γ}{Γ'} (sΠ σ τ vs svs σ' p sσ' f) r v = 
    ((a : Val Γ (σ [ embˢ vs ]⁺))(sa : SCV sσ' p  a) -> 
     Σ (Val Γ (τ [ embˢ vs < emb a ]⁺)) 
       \v' -> (vapp v & r & a ⇓ v') ×
              Σ (τ [ embˢ vs < emb a ]⁺ ≡⁺ emb⁺ (σ₁ (f a sa)))
                \p' -> SCV (π₂ (σ₂ (f a sa))) p' v')

  data SCE {Γ : Con} : forall {Δ} -> Env Γ Δ -> Set where
    se : SCE e
    s<< : forall {Γ' Δ σ}{vs : Env Γ Δ} -> SCE vs -> (σ' : VTy Γ')
          (p : σ [ embˢ vs ]⁺ ≡⁺ emb⁺ σ')(sσ' : SC σ')(v : Val Γ (σ [ embˢ vs ]⁺)) -> 
          SCV sσ' p v -> SCE (vs << v)

lemvapp : forall {Γ Γ' Δ σ τ ρ}{ts : Sub Γ Δ}
           {f : Val Γ' ρ}(p p' : ρ ≡⁺ Π σ τ [ ts ]⁺) -> 
           {v : Val Γ (σ [ ts ]⁺)}{v' v'' : Val Γ _} ->
           vapp f & p & v ⇓ v' -> vapp f & p' & v ⇓ v''
lemvapp = {! !}
           
mutual
  lem : forall {Γ Γ' Γ''}{σ'' : Ty Γ''}{σ}{v : Val Γ σ}{σ' : VTy Γ'}
        {p : σ ≡⁺ emb⁺ σ'}(sσ' : SC σ')(q : σ ≡⁺ σ'') -> SCV sσ' p v -> 
        SCV sσ' (trans⁺ (sym⁺ q) p) (coev v q)
  lem sU q sv = void 
  lem (sEl σ sσ) q sv = void 
  lem (sΠ σ τ vs svs σ' p sσ' f) r sv = 
    \a sa -> let x = f a sa
                 y = sv a sa  
                 z = lem (π₂ (σ₂ x)) (σ₁ (π₂ (σ₂ y))) (σ₂ (π₂ (σ₂ y))) 
             in  sig (σ₁ y) 
                     (pr {! !} 
                         (sig (σ₁ (π₂ (σ₂ y)))
                              {! !}))

  lemˢ : forall {Γ Γ' Δ Δ'}{vs : Env Γ Δ}(p : Γ ≡ˠ Γ')(q : Δ ≡ˠ Δ') ->
        SCE vs -> SCE (coevˢ vs p q)
  lemˢ p congε        se                      = se 
  lemˢ p (cong, q q') (s<< {vs = vs} svs σ' r sσ' v sv) = 
    s<< (lemˢ p q svs) 
        σ' 
        (trans⁺ (sym⁺ (cong⁺ q' (cohvˢ vs p q))) r) 
        sσ'  
        (coev v (cong⁺ q' (cohvˢ vs p q)))
        ((lem sσ' (cong⁺ q' (cohvˢ vs p q)) sv))

mutual
  thrm⁺ : forall {Γ Δ}(σ : Ty Δ)(vs : Env Γ Δ) -> SCE vs ->
          Σ (VTy Γ) \σ' -> ev⁺ σ & vs ⇓ σ' × SC σ'
  thrm⁺ (coe⁺ σ p)  vs svs = sig (σ₁ x) 
                                 (pr (ev⁺coe⁺ (π₁ (σ₂ x))) (π₂ (σ₂ x)))  
    where x = thrm⁺ σ (coevˢ vs reflˠ (symˠ p)) (lemˢ reflˠ (symˠ p) svs)
  thrm⁺ (σ [ ts ]⁺) vs svs = {! !}
  thrm⁺ U           vs svs = sig VU (pr ev⁺U sU) 
  thrm⁺ (El σ)      vs svs = {! !}
  thrm⁺ (Π σ τ)     vs svs = 
    sig (VΠ σ τ vs) 
        (pr ev⁺Π 
            (sΠ σ 
                τ
                vs
                svs 
                (σ₁ x)
                (comev⁺ (π₁ (σ₂ x)))
                (π₂ (σ₂ x))
                (\v sv -> let y = thrm⁺ τ 
                                        (vs << v)
                                        (s<< svs 
                                             (σ₁ x)
                                             (comev⁺ (π₁ (σ₂ x)))
                                             (π₂ (σ₂ x))
                                             v 
                                             sv) 
                          in  sig (σ₁ y) (pr (π₁ (σ₂ y)) (π₂ (σ₂ y))))))
    where
    x = thrm⁺ σ vs svs

  thrm : forall {Γ Δ σ}(t : Tm Δ σ)(vs : Env Γ Δ) -> SCE vs -> 
         (σ' : VTy Γ)(p : ev⁺ σ & vs ⇓ σ')(sσ' : SC σ') ->
         Σ (Val Γ (σ [ embˢ vs ]⁺)) 
           \v -> ev t & vs ⇓ v × SCV sσ' (comev⁺ p) v
  thrm = {! !}